package matrixChainOrder;

import java.util.ArrayList;
import java.util.Arrays;

import org.junit.Assert;
import org.junit.Test;

public class MatrixChainOrderTests {

    /**
     * Verifies that calculateMatrixChainOrder throws an exception if the provided
     * dimensions array is null.
     */
    @Test
    public void calculateMatrixChainOrderThrowsIfNullArray() {
        // Setup input
        ArrayList<Integer> input = null;

        // Setup expected result
        String errorMessage = "Error: null dimensions array";

        // Call the function, expecting failure
        try {
            MatrixChainOrder.calculateMatrixChainOrder(input);

            // The call should have thrown an exception
            Assert.fail("Failed to throw exception on null input");
        } catch (Exception e) {
            Assert.assertEquals("Should have thrown exception on null array", errorMessage, e.getMessage());
        }
    }

    /**
     * Verifies that calculateMatrixChainOrder returns the correct chain for the
     * happy-path solution given in class.
     */
    @Test
    public void calculateMatrixChainOrderHappyPath1() {
        // Setup input
        ArrayList<Integer> input = new ArrayList<Integer>(Arrays.asList(10, 100, 5, 50));

        // Setup expected result
        MatrixChainOrderSolution expectedResult = new MatrixChainOrderSolution("((A1A2)A3)", 7500);

        // Call the function, expecting no failure
        try {
            MatrixChainOrderSolution actualResult = MatrixChainOrder.calculateMatrixChainOrder(input);

            // Verify the result
            Assert.assertEquals("Happy path test 1: strings",  expectedResult.parenthesizedChain, actualResult.parenthesizedChain);
            Assert.assertEquals("Happy path test 1: values",  expectedResult.scalarMultiplications, actualResult.scalarMultiplications);
        } catch (Exception e) {
            Assert.fail(String.format("Should not have thrown an exception (%s)", e.getMessage()));
        }
    }
}
